The Synthesis ToolKit in C++ (STK)

Home Information Classes Download Usage Mail List Requirements Links FAQ Tutorial

# stk::BlitSquare Class Reference

STK band-limited square wave class. More...

`#include <BlitSquare.h>`

Inheritance diagram for stk::BlitSquare:

List of all members.

## Public Member Functions
| BlitSquare (StkFloat frequency=220.0)
| Default constructor that initializes BLIT frequency to 220 Hz.
| ~BlitSquare ()
| Class destructor.
void | reset ()
| Resets the oscillator state and phase to 0.
void | setPhase (StkFloat phase)
| Set the phase of the signal.
StkFloat | getPhase () const
| Get the current phase of the signal.
void | setFrequency (StkFloat frequency)
| Set the impulse train rate in terms of a frequency in Hz.
void | setHarmonics (unsigned int nHarmonics=0)
| Set the number of harmonics generated in the signal.
StkFloat | lastOut (void) const
| Return the last computed output value.
StkFloat | tick (void)
| Compute and return one output sample.
StkFrames & | tick (StkFrames &frames, unsigned int channel=0)
| Fill a channel of the StkFrames object with computed outputs.

## Detailed Description

STK band-limited square wave class.

This class generates a band-limited square wave signal. It is derived in part from the approach reported by Stilson and Smith in "Alias-Free Digital Synthesis of Classic Analog Waveforms", 1996. The algorithm implemented in this class uses a SincM function with an even M value to achieve a bipolar bandlimited impulse train. This signal is then integrated to achieve a square waveform. The integration process has an associated DC offset so a DC blocking filter is applied at the output.

The user can specify both the fundamental frequency of the waveform and the number of harmonics contained in the resulting signal.

If nHarmonics is 0, then the signal will contain all harmonics up to half the sample rate. Note, however, that this setting may produce aliasing in the signal when the frequency is changing (no automatic modification of the number of harmonics is performed by the setFrequency() function). Also note that the harmonics of a square wave fall at odd integer multiples of the fundamental, so aliasing will happen with a lower fundamental than with the other Blit waveforms. This class is not guaranteed to be well behaved in the presence of significant aliasing.

Based on initial code of Robin Davies, 2005. Modified algorithm code by Gary Scavone, 2005 - 2006.

## Member Function Documentation

void stk::BlitSquare::setPhase | ( | StkFloat | phase | ) | `[inline]`

Set the phase of the signal.

Set the phase of the signal, in the range 0 to 1.

    00058 { phase_ = PI * phase; };

StkFloat stk::BlitSquare::getPhase | ( |  | ) | const`[inline]`

Get the current phase of the signal.

Get the phase of the signal, in the range [0 to 1.0).

    00064 { return phase_ / PI; };

void stk::BlitSquare::setHarmonics | ( | unsigned int | nHarmonics = `0` | ) |

Set the number of harmonics generated in the signal.

This function sets the number of harmonics contained in the resulting signal. It is equivalent to (2 * M) + 1 in the BLIT algorithm. The default value of 0 sets the algorithm for maximum harmonic content (harmonics up to half the sample rate). This parameter is not checked against the current sample rate and fundamental frequency. Thus, aliasing can result if one or more harmonics for a given fundamental frequency exceeds fs / 2. This behavior was chosen over the potentially more problematic solution of automatically modifying the M parameter, which can produce audible clicks in the signal.

StkFrames & stk::BlitSquare::tick | ( | StkFrames & | frames,
|  | unsigned int | channel = `0` |
| ) |  |  | `[inline, virtual]`

Fill a channel of the StkFrames object with computed outputs.

The `channel` argument must be less than the number of channels in the StkFrames argument (the first channel is specified by 0). However, range checking is only performed if _STK_DEBUG_ is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

Implements stk::Generator.

    00152 {
    00153 #if defined(_STK_DEBUG_)
    00154   if ( channel >= frames.channels() ) {
    00155     oStream_ << "BlitSquare::tick(): channel and StkFrames arguments are incompatible!";
    00156     handleError( StkError::FUNCTION_ARGUMENT );
    00157   }
    00158 #endif
    00159
    00160   StkFloat *samples = &frames[channel];
    00161   unsigned int hop = frames.channels();
    00162   for ( unsigned int i=0; i<frames.frames(); i++, samples += hop )
    00163     *samples = BlitSquare::tick();
    00164
    00165   return frames;
    00166 }

The documentation for this class was generated from the following file:

- BlitSquare.h

The Synthesis ToolKit in C++ (STK)
©1995-2012 Perry R. Cook and Gary P. Scavone. All Rights Reserved.